unit U_ReceivableList;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxGraphics, cxCustomData, cxStyles, cxTL, cxMaskEdit, DB, ADODB,
  cxInplaceContainer, cxDBTL, cxControls, cxTLData, ComCtrls, ToolWin, StdCtrls,
  cxFilter, cxData, cxDataStorage, cxEdit, cxDBData, DBClient,
  cxGridCustomTableView, cxGridTableView, cxGridDBTableView, ExtCtrls,
  cxSplitter, cxGridLevel, cxClasses, cxGridCustomView, cxGrid,
  cxGridCustomPopupMenu, cxGridPopupMenu, RM_Dataset, RM_System, RM_Common,
  RM_Class, RM_GridReport, IdBaseComponent, IdComponent, IdTCPConnection,
  IdTCPClient, IdFTP, ShellAPI, IniFiles, cxCheckBox, cxCalendar, cxButtonEdit,
  cxTextEdit, cxPC, cxDropDownEdit, cxLookAndFeels, cxLookAndFeelPainters,
  cxNavigator, dxBarBuiltInMenu, dxDateRanges, U_BaseList, Vcl.Menus,
  Vcl.Clipbrd, cxContainer, dxCore, cxDateUtils, dxSkinsCore,
  dxSkinsDefaultPainters, dxScrollbarAnnotations, cxProgressBar, dxSkinWXI,
  cxCurrencyEdit;

type
  TfrmReceivableList = class(TfrmBaseList)
    ToolBar1: TToolBar;
    TBRafresh: TToolButton;
    btnDel: TToolButton;
    TBClose: TToolButton;
    ADOQueryTemp: TADOQuery;
    ADOQueryCmd: TADOQuery;
    Panel1: TPanel;
    ADOQueryMain: TADOQuery;
    RM1: TRMGridReport;
    RMDB_Main: TRMDBDataSet;
    Label3: TLabel;
    OppCoName: TcxTextEdit;
    GPM_1: TcxGridPopupMenu;
    DS_1: TDataSource;
    CDS_1: TClientDataSet;
    btnAdd: TToolButton;
    F_Name: TcxTextEdit;
    Label4: TLabel;
    Label6: TLabel;
    P_Code: TcxTextEdit;
    cxTabControl1: TcxTabControl;
    Label10: TLabel;
    ConNo: TcxTextEdit;
    Label11: TLabel;
    BuyConNo: TcxTextEdit;
    btnChk: TToolButton;
    btnReChk: TToolButton;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    ToolButton4: TToolButton;
    Label2: TLabel;
    OppParentCoName: TcxTextEdit;
    ToolButton5: TToolButton;
    N2: TMenuItem;
    btnEdit: TToolButton;
    N3: TMenuItem;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    Label1: TLabel;
    begdate: TcxDateEdit;
    Enddate: TcxDateEdit;
    CheckBox1: TcxCheckBox;
    cxGrid1: TcxGrid;
    Tv1: TcxGridDBTableView;
    Tv1Column22: TcxGridDBColumn;
    Tv1FFTime: TcxGridDBColumn;
    Tv1oppShuiNo: TcxGridDBColumn;
    Tv1OppCoName: TcxGridDBColumn;
    Tv1ourShuiNo: TcxGridDBColumn;
    TV1OurCoName: TcxGridDBColumn;
    Tv1FFAbstract: TcxGridDBColumn;
    Tv1ConNo: TcxGridDBColumn;
    Tv1OrderNo: TcxGridDBColumn;
    Tv1BuyConNo: TcxGridDBColumn;
    Tv1F_Code: TcxGridDBColumn;
    Tv1F_Name: TcxGridDBColumn;
    Tv1F_Width: TcxGridDBColumn;
    Tv1F_GramWeight: TcxGridDBColumn;
    Tv1F_Color: TcxGridDBColumn;
    Tv1Piece: TcxGridDBColumn;
    Tv1Qty: TcxGridDBColumn;
    Tv1QtyUnit: TcxGridDBColumn;
    Tv1Currency: TcxGridDBColumn;
    Tv1NoTaxPrice: TcxGridDBColumn;
    Tv1TaxRate: TcxGridDBColumn;
    Tv1TaxInclude: TcxGridDBColumn;
    Tv1Note: TcxGridDBColumn;
    Tv1FromID1: TcxGridDBColumn;
    cxGridLevel1: TcxGridLevel;
    Tv1Column1: TcxGridDBColumn;
    Tv1Column2: TcxGridDBColumn;
    ToolButton6: TToolButton;
    Tv1NoTaxInclude: TcxGridDBColumn;
    Tv1invoice_no: TcxGridDBColumn;
    Tv1customs_declare_no: TcxGridDBColumn;
    Tv1invoice_date: TcxGridDBColumn;
    Tv1payment_term: TcxGridDBColumn;
    Tv1due_receive_date: TcxGridDBColumn;
    Tv1Checkstatus: TcxGridDBColumn;
    Tv1Chker: TcxGridDBColumn;
    Tv1Chktime: TcxGridDBColumn;
    Tv1CollectStatus: TcxGridDBColumn;
    Tv1CollectDate: TcxGridDBColumn;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TBCloseClick(Sender: TObject);
    procedure btnDelClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure cxGridDBColumn5PropertiesEditValueChanged(Sender: TObject);
    procedure btnAddClick(Sender: TObject);
    procedure OppCoNameKeyPress(Sender: TObject; var Key: Char);
    procedure cxTabControl1Change(Sender: TObject);
    procedure btnChkClick(Sender: TObject);
    procedure btnReChkClick(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure ToolButton5Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure btnEditClick(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure ToolButton6Click(Sender: TObject);
  private
    procedure InitGrid();
    procedure SetStatus();
  public
    FAuthority: string;
  end;

implementation

uses
  U_DataLink, U_RTFun, U_ZDYHelp, U_ReceivableInput, U_ReceivableEdit,
  U_ReceivableImport, U_AttachmentUpload, U_GETableBatchInput;

{$R *.dfm}
procedure TfrmReceivableList.SetStatus();
begin

  btnChk.Enabled := false;     //审核
  btnReChk.Enabled := false;     //撤销

  btnAdd.Enabled := false;     //新增
  btnEdit.Enabled := false;     //修改
  btnDel.Enabled := false;           //删除

//  if Trim(FAuthority) = '管理' then
  begin
    btnAdd.Enabled := true;
    case cxTabControl1.TabIndex of
      0:
        begin
          btnEdit.Enabled := true;
          btnDel.Enabled := true;
          btnChk.Enabled := true;
        end;
      1:
        begin
          btnReChk.Enabled := true;
        end;
      2:
        begin

        end;
    end;
  end;
end;

procedure TfrmReceivableList.InitGrid();
var
  WSql: string;
begin
  WSql := SGetFilters(Panel1, 1, 2);
  if Trim(WSql) <> '' then
    WSql := ' and ' + WSql
  else
    CheckBox1.Checked := True;

  try
    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Close;
      SQL.Clear;
      Filtered := False;

      sql.Add(' select A.* ');
      sql.Add(' ,CASE WHEN EXISTS (SELECT 1 ');
      sql.Add('   FROM Finance_Flow R ');
      sql.Add('   WHERE R.FFType = ''收款登记'' ');
      sql.Add('     AND R.IVID IS NOT NULL ');
      sql.Add('     AND '','' + R.IVID + '','' LIKE ''%,'' + A.FFID + '',%'' ');
      sql.Add(' ) THEN ''已收款'' ELSE ''未收款'' END AS CollectStatus ');

      sql.Add(' ,(SELECT TOP 1 R.FFTime ');
      sql.Add('   FROM Finance_Flow R ');
      sql.Add('   WHERE R.FFType = ''收款登记'' ');
      sql.Add('     AND R.IVID IS NOT NULL ');
      sql.Add('     AND '','' + R.IVID + '','' LIKE ''%,'' + A.FFID + '',%'' ');
      sql.Add('   ORDER BY R.FFTime DESC ');
      sql.Add(' ) AS CollectDate ');
      sql.Add(',FJFlag=CAST((CASE WHEN (SELECT COUNT(X.FileName) FROM FJ_File X where X.TFType=''财务流水'' and X.WBID=A.FFID)>0 THEN 1 ELSE 0 END) AS BIT)');

      sql.Add(' FROM Finance_Flow A ');
      sql.Add(' where A.FFType=''应收款登记''  ');
      case cxTabControl1.TabIndex of
        0:
          begin
            sql.Add(' and isnull(Checkstatus,''未审核'')=''未审核'' ');
          end;
        1:
          begin
            sql.Add(' and isnull(Checkstatus,''未审核'')=''已审核'' ');
          end;
      end;
      if CheckBox1.Checked then
      begin
        sql.Add(' and A.FFTime>=''' + FormatDateTime('yyyy-MM-dd', begdate.Date) + ''' ');
        sql.Add(' and FFTime<''' + FormatDateTime('yyyy-MM-dd', Enddate.Date + 1) + ''' ');
      end;
      sql.Add(WSql);
      Open;
    end;
    SCreateCDS(ADOQueryMain, CDS_1);
    SInitCDSData(ADOQueryMain, CDS_1);
  finally
    ADOQueryMain.EnableControls;
    TV1.DataController.Filter.Clear;
  end;
end;

procedure TfrmReceivableList.N1Click(Sender: TObject);
begin
  SelOKNo(CDS_1, true)
end;

procedure TfrmReceivableList.N2Click(Sender: TObject);
begin
  Clipboard.SetTextBuf(PChar(Trim(CDS_1.fieldbyname(TV1.Controller.FocusedColumn.DataBinding.FilterFieldName).AsString)));
end;

procedure TfrmReceivableList.N3Click(Sender: TObject);
begin
  SelOKNo(CDS_1, false)

end;

procedure TfrmReceivableList.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  inherited;
  Action := caFree;
end;

procedure TfrmReceivableList.TBCloseClick(Sender: TObject);
begin

  Close;
end;

procedure TfrmReceivableList.btnDelClick(Sender: TObject);
var
  FFFIDS: string;
begin
  if CDS_1.IsEmpty then
    exit;

  if not CDS_1.Locate('SSel', True, []) then
  begin
    application.MessageBox('请选择数据', '提示');
    Exit;
  end;
  with CDS_1 do
  begin
    DisableControls;
    while CDS_1.Locate('SSel', True, []) do
    begin
      FFFIDS := FFFIDS + Trim(CDS_1.fieldbyname('FFID').AsString) + ',';
      CDS_1.Delete;
    end;
    EnableControls;
  end;
  try
    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add(' exec P_Fin_Flow_Del ');
      sql.Add(' @FFIDS=' + QuotedStr(FFFIDS));
      Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
      Sql.Add(',@DName=' + quotedstr(Trim(DName)));
      open;
    end;
    if ADOQueryCmd.FieldByName('intReturn').AsInteger = -1 then
      raise Exception.Create(pchar(trim(ADOQueryCmd.FieldByName('ShowMsg').AsString)));
    application.MessageBox('删除成功', '提示');
  except
    application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
    InitGrid();
  end;
end;

procedure TfrmReceivableList.FormShow(Sender: TObject);
begin
  inherited;
  ReadCxGrid(trim(Self.Caption), Tv1, '财务管理');
  Enddate.Date := SGetServerDate(ADOQueryTemp);
  begdate.Date := Enddate.Date - 30;
  SetStatus();
  InitGrid();
end;

procedure TfrmReceivableList.TBRafreshClick(Sender: TObject);
begin
  toolbar1.SetFocus;
  with ADOQueryCmd do
  begin
    Close;
    Sql.Clear;
    Sql.Add('exec P_Fin_Generate ');
    Open;
  end;
  if ADOQueryCmd.FieldByName('intReturn').AsInteger = -1 then
  begin
    application.MessageBox(pchar(ADOQueryCmd.FieldByName('ShowMsg').AsString), '提示信息');
    Exit;
  end;
  InitGrid();

end;

procedure TfrmReceivableList.cxGridDBColumn5PropertiesEditValueChanged(Sender: TObject);
var
  mvalue, FFieldName: string;
  FPS, FQty, FPrice, FQTFee, FMoney, FZKMoney: Double;
begin
  FFieldName := Trim(Tv1.Controller.FocusedColumn.DataBinding.FilterFieldName);
  mvalue := TcxTextEdit(Sender).EditingText;
  if Trim(mvalue) = '' then
  begin
    mvalue := '0';
  end;

  with CDS_1 do
  begin
    Edit;
    FieldByName(FFieldName).Value := Trim(mvalue);
    Post;
    FPS := CDS_1.fieldbyname('PS').AsFloat;
    FQty := CDS_1.fieldbyname('Qty').AsFloat;
    FQTFee := CDS_1.fieldbyname('QTFee').AsFloat;
    FPrice := CDS_1.fieldbyname('Price').AsFloat;
    FMoney := CDS_1.fieldbyname('Money').AsFloat;

    FZKMoney := CDS_1.fieldbyname('ZKMoney').AsFloat;
  end;

  if Trim(FFieldName) <> 'Money' then
  begin
    FMoney := FQty * FPrice + FQTFee - FZKMoney;
  end;
  with CDS_1 do
  begin
    Edit;
    FieldByName('Money').Value := FMoney;
    Post;
  end;
  with ADOQueryCmd do
  begin
    Close;
    SQL.Clear;
    sql.Add('update Finance_Flow set ' + FFieldName + '=' + Trim(mvalue));
    if Trim(FFieldName) <> 'Money' then
      sql.Add(' ,Money=' + FloatToStr(FMoney));
    sql.Add('where FFID=' + quotedstr(Trim(CDS_1.fieldbyname('FFID').AsString)));
    ExecSQL;
  end;

  Tv1.Controller.EditingController.ShowEdit();
end;

procedure TfrmReceivableList.btnChkClick(Sender: TObject);
var
  FFFIDS: string;
begin
  if CDS_1.IsEmpty then
    exit;

  if not CDS_1.Locate('SSel', True, []) then
  begin
    application.MessageBox('请选择数据', '提示');
    Exit;
  end;

  with CDS_1 do
  begin
    DisableControls;
    while CDS_1.Locate('SSel', True, []) do
    begin
      FFFIDS := FFFIDS + Trim(CDS_1.fieldbyname('FFID').AsString) + ',';
      CDS_1.Delete;
    end;
    EnableControls;
  end;

  try
    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add(' exec P_Fin_Flow_SetStatus ');
      sql.Add(' @FFIDS=' + QuotedStr(FFFIDS));
      sql.Add(',@Operation=''审核'' ');
      Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
      Sql.Add(',@DName=' + quotedstr(Trim(DName)));
      open;
    end;
    if ADOQueryCmd.FieldByName('intReturn').AsInteger = -1 then
      raise Exception.Create(pchar(trim(ADOQueryCmd.FieldByName('ShowMsg').AsString)));
    application.MessageBox('审核成功', '提示');
  except
    application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
    InitGrid();
  end;

end;

procedure TfrmReceivableList.btnReChkClick(Sender: TObject);
var
  FFFIDS: string;
begin
  if CDS_1.IsEmpty then
    exit;

  if not CDS_1.Locate('SSel', True, []) then
  begin
    application.MessageBox('请选择数据', '提示');
    Exit;
  end;

  with CDS_1 do
  begin
    DisableControls;
    while CDS_1.Locate('SSel', True, []) do
    begin
      FFFIDS := FFFIDS + Trim(CDS_1.fieldbyname('FFID').AsString) + ',';
      CDS_1.Delete;
    end;
    EnableControls;
  end;

  try
    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add(' exec P_Fin_Flow_SetStatus ');
      sql.Add(' @FFIDS=' + QuotedStr(FFFIDS));
      sql.Add(',@Operation=''撤销审核'' ');
      Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
      Sql.Add(',@DName=' + quotedstr(Trim(DName)));
      open;
    end;
    if ADOQueryCmd.FieldByName('intReturn').AsInteger = -1 then
      raise Exception.Create(pchar(trim(ADOQueryCmd.FieldByName('ShowMsg').AsString)));
    application.MessageBox('撤销审核成功', '提示');
  except
    application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
    InitGrid();
  end;
end;

procedure TfrmReceivableList.btnAddClick(Sender: TObject);
begin

  try
    frmReceivableInput := TfrmReceivableInput.Create(Application);
    with frmReceivableInput do
    begin
      FFFID := '';
      if ShowModal = 1 then
      begin
        InitGrid();
      end;
    end;
  finally
    frmReceivableInput.Free;
  end;
end;

procedure TfrmReceivableList.ToolButton1Click(Sender: TObject);
var
  MFFIDS: string;
begin
  if CDS_1.IsEmpty then
    exit;

  if not CDS_1.Locate('SSel', True, []) then
  begin
    application.MessageBox('请选择数据', '提示');
    Exit;
  end;

  with CDS_1 do
  begin
    DisableControls;
    while CDS_1.Locate('SSel', True, []) do
    begin
      MFFIDS := MFFIDS + Trim(CDS_1.fieldbyname('FFID').AsString) + ',';
      CDS_1.Delete;
    end;
    EnableControls;
  end;

  try
    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add(' exec P_Fin_Flow_Judge ');
      sql.Add(' @FFIDS=' + QuotedStr(MFFIDS));
      Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
      Sql.Add(',@DName=' + quotedstr(Trim(DName)));
      open;
    end;
    if ADOQueryCmd.FieldByName('intReturn').AsInteger = -1 then
      raise Exception.Create(pchar(trim(ADOQueryCmd.FieldByName('ShowMsg').AsString)));
  except
    application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
    Exit;
  end;

  try
    frmReceivableEdit := TfrmReceivableEdit.Create(Application);
    with frmReceivableEdit do
    begin
      FFFIDS := MFFIDS;
      if ShowModal = 1 then
      begin
        InitGrid();
      end;
    end;
  finally
    frmReceivableEdit.Free;
  end;
end;

procedure TfrmReceivableList.ToolButton2Click(Sender: TObject);
begin
  try
    frmReceivableImport := TfrmReceivableImport.Create(Application);
    with frmReceivableImport do
    begin

      if ShowModal = 1 then
      begin
        InitGrid();
      end;
    end;
  finally
    frmReceivableImport.Free;
  end;
end;

procedure TfrmReceivableList.ToolButton3Click(Sender: TObject);
begin
  if CDS_1.IsEmpty then
    Exit;
  try
    frmAttachmentUpload := TfrmAttachmentUpload.Create(Application);
    with frmAttachmentUpload do
    begin
      fkeyNO := Trim(Self.CDS_1.fieldbyname('FFID').AsString);
      fType := '财务流水';
      FEditAuthority := True;
      if ShowModal = 1 then
      begin

      end;
    end;
  finally
    frmAttachmentUpload.Free;
  end;
end;

procedure TfrmReceivableList.ToolButton4Click(Sender: TObject);
begin
  if ADOQueryMain.IsEmpty then
    Exit;
  TcxGridToExcel(self.Caption, cxgrid1);
end;

procedure TfrmReceivableList.ToolButton5Click(Sender: TObject);
begin
  WriteCxGrid(trim(Self.Caption), Tv1, '财务管理');
end;

procedure TfrmReceivableList.ToolButton6Click(Sender: TObject);
begin
  try
    frmgetableBatchInput := TfrmgetableBatchInput.Create(Application);
    with frmgetableBatchInput do
    begin
      FFFID := '';
      if ShowModal = 1 then
      begin
        InitGrid();
      end;
    end;
  finally
    frmgetableBatchInput.Free;
  end;
end;

procedure TfrmReceivableList.btnEditClick(Sender: TObject);
begin
  try
    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add(' exec P_Fin_Flow_Judge ');
      sql.Add(' @FFIDS=' + QuotedStr(Trim(SELF.CDS_1.fieldbyname('FFID').AsString)));
      Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
      Sql.Add(',@DName=' + quotedstr(Trim(DName)));
      open;
    end;
    if ADOQueryCmd.FieldByName('intReturn').AsInteger = -1 then
      raise Exception.Create(pchar(trim(ADOQueryCmd.FieldByName('ShowMsg').AsString)));
  except
    application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
    Exit;
  end;

  try
    frmGetableBatchInput := TfrmGetableBatchInput.Create(Application);
    with frmGetableBatchInput do
    begin
      FFFID := Trim(SELF.CDS_1.fieldbyname('FFID').AsString);   // 传入要修改的 FFID
      if ShowModal = 1 then
        InitGrid();      // 修改成功后刷新列表
    end;
  finally
    frmGetableBatchInput.Free;
  end;
end;

procedure TfrmReceivableList.OppCoNameKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    InitGrid();
  end;
end;

procedure TfrmReceivableList.cxTabControl1Change(Sender: TObject);
begin
  SetStatus();
  InitGrid();
end;

end.

